import { AccountKeyLinkTransactionBodyBuilder } from './AccountKeyLinkTransactionBodyBuilder';
import { EmbeddedTransactionBuilder, EmbeddedTransactionBuilderParams } from './EmbeddedTransactionBuilder';
import { EntityTypeDto } from './EntityTypeDto';
import { KeyDto } from './KeyDto';
import { LinkActionDto } from './LinkActionDto';
import { NetworkTypeDto } from './NetworkTypeDto';
import { Serializer } from './Serializer';
export interface EmbeddedAccountKeyLinkTransactionBuilderParams extends EmbeddedTransactionBuilderParams {
    signerPublicKey: KeyDto;
    version: number;
    network: NetworkTypeDto;
    type: EntityTypeDto;
    linkedPublicKey: KeyDto;
    linkAction: LinkActionDto;
}
export declare class EmbeddedAccountKeyLinkTransactionBuilder extends EmbeddedTransactionBuilder implements Serializer {
    readonly accountKeyLinkTransactionBody: AccountKeyLinkTransactionBodyBuilder;
    constructor({ signerPublicKey, version, network, type, linkedPublicKey, linkAction, }: EmbeddedAccountKeyLinkTransactionBuilderParams);
    static loadFromBinary(payload: Uint8Array): EmbeddedAccountKeyLinkTransactionBuilder;
    static createEmbeddedAccountKeyLinkTransactionBuilder(signerPublicKey: KeyDto, version: number, network: NetworkTypeDto, type: EntityTypeDto, linkedPublicKey: KeyDto, linkAction: LinkActionDto): EmbeddedAccountKeyLinkTransactionBuilder;
    get linkedPublicKey(): KeyDto;
    get linkAction(): LinkActionDto;
    get size(): number;
    get body(): AccountKeyLinkTransactionBodyBuilder;
    serialize(): Uint8Array;
}
