import { AliasActionDto } from './AliasActionDto';
import { EmbeddedTransactionBuilder, EmbeddedTransactionBuilderParams } from './EmbeddedTransactionBuilder';
import { EntityTypeDto } from './EntityTypeDto';
import { KeyDto } from './KeyDto';
import { MosaicAliasTransactionBodyBuilder } from './MosaicAliasTransactionBodyBuilder';
import { MosaicIdDto } from './MosaicIdDto';
import { NamespaceIdDto } from './NamespaceIdDto';
import { NetworkTypeDto } from './NetworkTypeDto';
import { Serializer } from './Serializer';
export interface EmbeddedMosaicAliasTransactionBuilderParams extends EmbeddedTransactionBuilderParams {
    signerPublicKey: KeyDto;
    version: number;
    network: NetworkTypeDto;
    type: EntityTypeDto;
    namespaceId: NamespaceIdDto;
    mosaicId: MosaicIdDto;
    aliasAction: AliasActionDto;
}
export declare class EmbeddedMosaicAliasTransactionBuilder extends EmbeddedTransactionBuilder implements Serializer {
    readonly mosaicAliasTransactionBody: MosaicAliasTransactionBodyBuilder;
    constructor({ signerPublicKey, version, network, type, namespaceId, mosaicId, aliasAction, }: EmbeddedMosaicAliasTransactionBuilderParams);
    static loadFromBinary(payload: Uint8Array): EmbeddedMosaicAliasTransactionBuilder;
    static createEmbeddedMosaicAliasTransactionBuilder(signerPublicKey: KeyDto, version: number, network: NetworkTypeDto, type: EntityTypeDto, namespaceId: NamespaceIdDto, mosaicId: MosaicIdDto, aliasAction: AliasActionDto): EmbeddedMosaicAliasTransactionBuilder;
    get namespaceId(): NamespaceIdDto;
    get mosaicId(): MosaicIdDto;
    get aliasAction(): AliasActionDto;
    get size(): number;
    get body(): MosaicAliasTransactionBodyBuilder;
    serialize(): Uint8Array;
}
