"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmbeddedMosaicDefinitionTransactionBuilder = void 0;
const EmbeddedTransactionBuilder_1 = require("./EmbeddedTransactionBuilder");
const GeneratorUtils_1 = require("./GeneratorUtils");
const MosaicDefinitionTransactionBodyBuilder_1 = require("./MosaicDefinitionTransactionBodyBuilder");
class EmbeddedMosaicDefinitionTransactionBuilder extends EmbeddedTransactionBuilder_1.EmbeddedTransactionBuilder {
    constructor({ signerPublicKey, version, network, type, id, duration, nonce, flags, divisibility, }) {
        super({ signerPublicKey, version, network, type });
        this.mosaicDefinitionTransactionBody = new MosaicDefinitionTransactionBodyBuilder_1.MosaicDefinitionTransactionBodyBuilder({ id, duration, nonce, flags, divisibility });
    }
    static loadFromBinary(payload) {
        const byteArray = Array.from(payload);
        const superObject = EmbeddedTransactionBuilder_1.EmbeddedTransactionBuilder.loadFromBinary(payload);
        byteArray.splice(0, superObject.size);
        const mosaicDefinitionTransactionBody = MosaicDefinitionTransactionBodyBuilder_1.MosaicDefinitionTransactionBodyBuilder.loadFromBinary(Uint8Array.from(byteArray));
        byteArray.splice(0, mosaicDefinitionTransactionBody.size);
        return new EmbeddedMosaicDefinitionTransactionBuilder({
            signerPublicKey: superObject.signerPublicKey,
            version: superObject.version,
            network: superObject.network,
            type: superObject.type,
            id: mosaicDefinitionTransactionBody.id,
            duration: mosaicDefinitionTransactionBody.duration,
            nonce: mosaicDefinitionTransactionBody.nonce,
            flags: mosaicDefinitionTransactionBody.flags,
            divisibility: mosaicDefinitionTransactionBody.divisibility,
        });
    }
    static createEmbeddedMosaicDefinitionTransactionBuilder(signerPublicKey, version, network, type, id, duration, nonce, flags, divisibility) {
        return new EmbeddedMosaicDefinitionTransactionBuilder({
            signerPublicKey: signerPublicKey,
            version: version,
            network: network,
            type: type,
            id: id,
            duration: duration,
            nonce: nonce,
            flags: flags,
            divisibility: divisibility,
        });
    }
    get id() {
        return this.mosaicDefinitionTransactionBody.id;
    }
    get duration() {
        return this.mosaicDefinitionTransactionBody.duration;
    }
    get nonce() {
        return this.mosaicDefinitionTransactionBody.nonce;
    }
    get flags() {
        return this.mosaicDefinitionTransactionBody.flags;
    }
    get divisibility() {
        return this.mosaicDefinitionTransactionBody.divisibility;
    }
    get size() {
        let size = super.size;
        size += this.mosaicDefinitionTransactionBody.size;
        return size;
    }
    get body() {
        return this.mosaicDefinitionTransactionBody;
    }
    serialize() {
        let newArray = Uint8Array.from([]);
        const superBytes = super.serialize();
        newArray = GeneratorUtils_1.GeneratorUtils.concatTypedArrays(newArray, superBytes);
        const mosaicDefinitionTransactionBodyBytes = this.mosaicDefinitionTransactionBody.serialize();
        newArray = GeneratorUtils_1.GeneratorUtils.concatTypedArrays(newArray, mosaicDefinitionTransactionBodyBytes);
        return newArray;
    }
}
exports.EmbeddedMosaicDefinitionTransactionBuilder = EmbeddedMosaicDefinitionTransactionBuilder;
//# sourceMappingURL=EmbeddedMosaicDefinitionTransactionBuilder.js.map