import { EmbeddedTransactionBuilder, EmbeddedTransactionBuilderParams } from './EmbeddedTransactionBuilder';
import { EntityTypeDto } from './EntityTypeDto';
import { KeyDto } from './KeyDto';
import { MultisigAccountModificationTransactionBodyBuilder } from './MultisigAccountModificationTransactionBodyBuilder';
import { NetworkTypeDto } from './NetworkTypeDto';
import { Serializer } from './Serializer';
import { UnresolvedAddressDto } from './UnresolvedAddressDto';
export interface EmbeddedMultisigAccountModificationTransactionBuilderParams extends EmbeddedTransactionBuilderParams {
    signerPublicKey: KeyDto;
    version: number;
    network: NetworkTypeDto;
    type: EntityTypeDto;
    minRemovalDelta: number;
    minApprovalDelta: number;
    addressAdditions: UnresolvedAddressDto[];
    addressDeletions: UnresolvedAddressDto[];
}
export declare class EmbeddedMultisigAccountModificationTransactionBuilder extends EmbeddedTransactionBuilder implements Serializer {
    readonly multisigAccountModificationTransactionBody: MultisigAccountModificationTransactionBodyBuilder;
    constructor({ signerPublicKey, version, network, type, minRemovalDelta, minApprovalDelta, addressAdditions, addressDeletions, }: EmbeddedMultisigAccountModificationTransactionBuilderParams);
    static loadFromBinary(payload: Uint8Array): EmbeddedMultisigAccountModificationTransactionBuilder;
    static createEmbeddedMultisigAccountModificationTransactionBuilder(signerPublicKey: KeyDto, version: number, network: NetworkTypeDto, type: EntityTypeDto, minRemovalDelta: number, minApprovalDelta: number, addressAdditions: UnresolvedAddressDto[], addressDeletions: UnresolvedAddressDto[]): EmbeddedMultisigAccountModificationTransactionBuilder;
    get minRemovalDelta(): number;
    get minApprovalDelta(): number;
    get addressAdditions(): UnresolvedAddressDto[];
    get addressDeletions(): UnresolvedAddressDto[];
    get size(): number;
    get body(): MultisigAccountModificationTransactionBodyBuilder;
    serialize(): Uint8Array;
}
