import { BlockDurationDto } from './BlockDurationDto';
import { EmbeddedTransactionBuilder, EmbeddedTransactionBuilderParams } from './EmbeddedTransactionBuilder';
import { EntityTypeDto } from './EntityTypeDto';
import { KeyDto } from './KeyDto';
import { NamespaceIdDto } from './NamespaceIdDto';
import { NamespaceRegistrationTransactionBodyBuilder } from './NamespaceRegistrationTransactionBodyBuilder';
import { NamespaceRegistrationTypeDto } from './NamespaceRegistrationTypeDto';
import { NetworkTypeDto } from './NetworkTypeDto';
import { Serializer } from './Serializer';
export interface EmbeddedNamespaceRegistrationTransactionBuilderParams extends EmbeddedTransactionBuilderParams {
    signerPublicKey: KeyDto;
    version: number;
    network: NetworkTypeDto;
    type: EntityTypeDto;
    duration?: BlockDurationDto;
    parentId?: NamespaceIdDto;
    id: NamespaceIdDto;
    registrationType: NamespaceRegistrationTypeDto;
    name: Uint8Array;
}
export declare class EmbeddedNamespaceRegistrationTransactionBuilder extends EmbeddedTransactionBuilder implements Serializer {
    readonly namespaceRegistrationTransactionBody: NamespaceRegistrationTransactionBodyBuilder;
    constructor({ signerPublicKey, version, network, type, duration, parentId, id, registrationType, name, }: EmbeddedNamespaceRegistrationTransactionBuilderParams);
    static loadFromBinary(payload: Uint8Array): EmbeddedNamespaceRegistrationTransactionBuilder;
    static createEmbeddedNamespaceRegistrationTransactionBuilderChild(signerPublicKey: KeyDto, version: number, network: NetworkTypeDto, type: EntityTypeDto, parentId: NamespaceIdDto, id: NamespaceIdDto, name: Uint8Array): EmbeddedNamespaceRegistrationTransactionBuilder;
    static createEmbeddedNamespaceRegistrationTransactionBuilderRoot(signerPublicKey: KeyDto, version: number, network: NetworkTypeDto, type: EntityTypeDto, duration: BlockDurationDto, id: NamespaceIdDto, name: Uint8Array): EmbeddedNamespaceRegistrationTransactionBuilder;
    get duration(): BlockDurationDto | undefined;
    get parentId(): NamespaceIdDto | undefined;
    get id(): NamespaceIdDto;
    get registrationType(): NamespaceRegistrationTypeDto;
    get name(): Uint8Array;
    get size(): number;
    get body(): NamespaceRegistrationTransactionBodyBuilder;
    serialize(): Uint8Array;
}
