import { AmountDto } from './AmountDto';
import { EntityTypeDto } from './EntityTypeDto';
import { KeyDto } from './KeyDto';
import { MosaicGlobalRestrictionTransactionBodyBuilder } from './MosaicGlobalRestrictionTransactionBodyBuilder';
import { MosaicRestrictionTypeDto } from './MosaicRestrictionTypeDto';
import { NetworkTypeDto } from './NetworkTypeDto';
import { Serializer } from './Serializer';
import { SignatureDto } from './SignatureDto';
import { TimestampDto } from './TimestampDto';
import { TransactionBuilder, TransactionBuilderParams } from './TransactionBuilder';
import { UnresolvedMosaicIdDto } from './UnresolvedMosaicIdDto';
export interface MosaicGlobalRestrictionTransactionBuilderParams extends TransactionBuilderParams {
    signature: SignatureDto;
    signerPublicKey: KeyDto;
    version: number;
    network: NetworkTypeDto;
    type: EntityTypeDto;
    fee: AmountDto;
    deadline: TimestampDto;
    mosaicId: UnresolvedMosaicIdDto;
    referenceMosaicId: UnresolvedMosaicIdDto;
    restrictionKey: bigint;
    previousRestrictionValue: bigint;
    newRestrictionValue: bigint;
    previousRestrictionType: MosaicRestrictionTypeDto;
    newRestrictionType: MosaicRestrictionTypeDto;
}
export declare class MosaicGlobalRestrictionTransactionBuilder extends TransactionBuilder implements Serializer {
    readonly mosaicGlobalRestrictionTransactionBody: MosaicGlobalRestrictionTransactionBodyBuilder;
    constructor({ signature, signerPublicKey, version, network, type, fee, deadline, mosaicId, referenceMosaicId, restrictionKey, previousRestrictionValue, newRestrictionValue, previousRestrictionType, newRestrictionType, }: MosaicGlobalRestrictionTransactionBuilderParams);
    static loadFromBinary(payload: Uint8Array): MosaicGlobalRestrictionTransactionBuilder;
    static createMosaicGlobalRestrictionTransactionBuilder(signature: SignatureDto, signerPublicKey: KeyDto, version: number, network: NetworkTypeDto, type: EntityTypeDto, fee: AmountDto, deadline: TimestampDto, mosaicId: UnresolvedMosaicIdDto, referenceMosaicId: UnresolvedMosaicIdDto, restrictionKey: bigint, previousRestrictionValue: bigint, newRestrictionValue: bigint, previousRestrictionType: MosaicRestrictionTypeDto, newRestrictionType: MosaicRestrictionTypeDto): MosaicGlobalRestrictionTransactionBuilder;
    get mosaicId(): UnresolvedMosaicIdDto;
    get referenceMosaicId(): UnresolvedMosaicIdDto;
    get restrictionKey(): bigint;
    get previousRestrictionValue(): bigint;
    get newRestrictionValue(): bigint;
    get previousRestrictionType(): MosaicRestrictionTypeDto;
    get newRestrictionType(): MosaicRestrictionTypeDto;
    get size(): number;
    get body(): MosaicGlobalRestrictionTransactionBodyBuilder;
    serialize(): Uint8Array;
}
